/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.72 Revision 1.162
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2015 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.72 2010/05/26 15:17:17 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.162 2015/03/23 02:15:14 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12case ${EAPI} in
13 4|5) : ;;
14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16 16
17MY_PV=${PV/_/-} 17inherit eutils flag-o-matic multilib toolchain-funcs
18if version_is_at_least 4.5.99999999; then 18
19HOMEPAGE="https://www.qt.io/ https://qt-project.org/"
20LICENSE="|| ( LGPL-2.1 GPL-3 )"
21SLOT="4"
22
23case ${PV} in
24 4.?.9999)
25 QT4_BUILD_TYPE="live"
26 EGIT_REPO_URI=(
27 "git://gitorious.org/qt/qt.git"
28 "https://git.gitorious.org/qt/qt.git"
29 )
30 EGIT_BRANCH=${PV%.9999}
31 inherit git-r3
32 ;;
33 *)
34 QT4_BUILD_TYPE="release"
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 35 MY_P=qt-everywhere-opensource-src-${PV/_/-}
36 SRC_URI="http://download.qt.io/archive/qt/${PV%.*}/${PV}/${MY_P}.tar.gz"
37 S=${WORKDIR}/${MY_P}
38 ;;
39esac
40
41IUSE="aqua debug pch"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 42[[ ${PN} != qtxmlpatterns ]] && IUSE+=" +exceptions"
21else 43
22 MY_P=qt-x11-opensource-src-${MY_PV} 44DEPEND="virtual/pkgconfig"
45if [[ ${QT4_BUILD_TYPE} == live ]]; then
46 DEPEND+=" dev-lang/perl"
23fi 47fi
24 48
25HOMEPAGE="http://qt.nokia.com/"
26SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
27
28LICENSE="|| ( LGPL-2.1 GPL-3 )"
29IUSE+=" debug pch aqua"
30
31RDEPEND="
32 !<x11-libs/qt-assistant-${PV}
33 !>x11-libs/qt-assistant-${PV}-r9999
34 !<x11-libs/qt-core-${PV}
35 !>x11-libs/qt-core-${PV}-r9999
36 !<x11-libs/qt-dbus-${PV}
37 !>x11-libs/qt-dbus-${PV}-r9999
38 !<x11-libs/qt-demo-${PV}
39 !>x11-libs/qt-demo-${PV}-r9999
40 !<x11-libs/qt-gui-${PV}
41 !>x11-libs/qt-gui-${PV}-r9999
42 !<x11-libs/qt-multimedia-${PV}
43 !>x11-libs/qt-multimedia-${PV}-r9999
44 !<x11-libs/qt-opengl-${PV}
45 !>x11-libs/qt-opengl-${PV}-r9999
46 !<x11-libs/qt-phonon-${PV}
47 !>x11-libs/qt-phonon-${PV}-r9999
48 !<x11-libs/qt-qt3support-${PV}
49 !>x11-libs/qt-qt3support-${PV}-r9999
50 !<x11-libs/qt-script-${PV}
51 !>x11-libs/qt-script-${PV}-r9999
52 !<x11-libs/qt-sql-${PV}
53 !>x11-libs/qt-sql-${PV}-r9999
54 !<x11-libs/qt-svg-${PV}
55 !>x11-libs/qt-svg-${PV}-r9999
56 !<x11-libs/qt-test-${PV}
57 !>x11-libs/qt-test-${PV}-r9999
58 !<x11-libs/qt-webkit-${PV}
59 !>x11-libs/qt-webkit-${PV}-r9999
60 !<x11-libs/qt-xmlpatterns-${PV}
61 !>x11-libs/qt-xmlpatterns-${PV}-r9999
62"
63
64S=${WORKDIR}/${MY_P}
65
66# @FUNCTION: qt4-build_pkg_setup 49# @FUNCTION: qt4-build_pkg_setup
67# @DESCRIPTION: 50# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 51# Sets up PATH and LD_LIBRARY_PATH.
69qt4-build_pkg_setup() { 52qt4-build_pkg_setup() {
70 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 53 # Warn users of possible breakage when downgrading to a previous release.
71
72 # Protect users by not allowing downgrades between releases
73 # Downgrading revisions within the same release should be allowed 54 # Downgrading revisions within the same release is safe.
74 if has_version '>'${CATEGORY}/${P}-r9999 ; then 55 if has_version ">${CATEGORY}/${P}-r9999:4"; then
75 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 56 ewarn
76 eerror "Sanity check to keep you from breaking your system:"
77 eerror " Downgrading Qt is completely unsupported and will break your system!"
78 die "aborting to save your system"
79 else
80 ewarn "Downgrading Qt is completely unsupported and will break your system!" 57 ewarn "Downgrading Qt is completely unsupported and can break your system!"
81 fi 58 ewarn
82 fi
83
84 if [[ "${PN}" == "qt-webkit" ]]; then
85 eshopts_push -s extglob
86 if is-flagq '-g?(gdb)?([0-9])'; then
87 echo
88 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
89 ewarn "You may experience really long compilation times and/or increased memory usage."
90 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
91 ewarn "For more info check out bug #307861"
92 echo
93 fi
94 eshopts_pop
95 fi 59 fi
96 60
97 PATH="${S}/bin${PATH:+:}${PATH}" 61 PATH="${S}/bin${PATH:+:}${PATH}"
98 if [[ ${CHOST} != *-darwin* ]]; then 62 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 63 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
104 # avoid extract failure. 68 # avoid extract failure.
105 [[ ${CHOST} == *-apple-darwin* ]] && \ 69 [[ ${CHOST} == *-apple-darwin* ]] && \
106 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 70 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
107 ${QT4_EXTRACT_DIRECTORIES}" 71 ${QT4_EXTRACT_DIRECTORIES}"
108 fi 72 fi
109
110 # Make sure ebuilds use the required EAPI
111 if [[ ${EAPI} != [23] ]]; then
112 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
113 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
114 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
115 die "qt4-build eclass requires EAPI=2 or EAPI=3"
116 fi
117
118 if ! version_is_at_least 4.1 $(gcc-version); then
119 ewarn "Using a GCC version lower than 4.1 is not supported!"
120 fi
121} 73}
74
75# @ECLASS-VARIABLE: PATCHES
76# @DEFAULT_UNSET
77# @DESCRIPTION:
78# Array variable containing all the patches to be applied. This variable
79# is expected to be defined in the global scope of ebuilds. Make sure to
80# specify the full path. This variable is used in src_prepare phase.
81#
82# Example:
83# @CODE
84# PATCHES=(
85# "${FILESDIR}/mypatch.patch"
86# "${FILESDIR}/patches_folder/"
87# )
88# @CODE
89
90# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
91# @DEFAULT_UNSET
92# @DESCRIPTION:
93# Space-separated list of directories that will be extracted
94# from Qt tarball.
122 95
123# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 96# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
97# @DEFAULT_UNSET
124# @DESCRIPTION: 98# @DESCRIPTION:
125# Arguments for build_target_directories. Takes the directories, in which the 99# Space-separated list of directories that will be configured,
126# code should be compiled. This is a space-separated list 100# compiled, and installed. All paths must be relative to ${S}.
127
128# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
129# @DESCRIPTION:
130# Space separated list including the directories that will be extracted from Qt
131# tarball
132 101
133# @FUNCTION: qt4-build_src_unpack 102# @FUNCTION: qt4-build_src_unpack
134# @DESCRIPTION: 103# @DESCRIPTION:
135# Unpacks the sources 104# Unpacks the sources.
136qt4-build_src_unpack() { 105qt4-build_src_unpack() {
137 setqtenv 106 setqtenv
138 local target targets= 107
108 if [[ $(gcc-major-version) -lt 4 ]] || [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 4 ]]; then
109 ewarn
110 ewarn "Using a GCC version lower than 4.4 is not supported."
111 ewarn
112 fi
113
114 if [[ ${PN} == qtwebkit ]]; then
115 eshopts_push -s extglob
116 if is-flagq '-g?(gdb)?([1-9])'; then
117 ewarn
118 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
119 ewarn "You may experience really long compilation times and/or increased memory usage."
120 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
121 ewarn "For more info check out https://bugs.gentoo.org/307861"
122 ewarn
123 fi
124 eshopts_pop
125 fi
126
127 case ${QT4_BUILD_TYPE} in
128 live)
129 git-r3_src_unpack
130 ;;
131 release)
132 local tarball="${MY_P}.tar.gz" target= targets=
139 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 133 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
140 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 134 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
141 ${QT4_EXTRACT_DIRECTORIES}; do 135 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
136 do
142 targets+=" ${MY_P}/${target}" 137 targets+="${MY_P}/${target} "
143 done 138 done
144 139
145 echo tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 140 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
146 tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 141 tar -xzf "${DISTDIR}/${tarball}" ${targets}
142 eend $? || die "failed to unpack"
143 ;;
144 esac
147} 145}
148
149# @ECLASS-VARIABLE: PATCHES
150# @DESCRIPTION:
151# In case you have patches to apply, specify them in PATCHES variable. Make sure
152# to specify the full path. This variable is necessary for src_prepare phase.
153# example:
154# PATCHES="${FILESDIR}"/mypatch.patch
155# ${FILESDIR}"/mypatch2.patch"
156#
157 146
158# @FUNCTION: qt4-build_src_prepare 147# @FUNCTION: qt4-build_src_prepare
159# @DESCRIPTION: 148# @DESCRIPTION:
160# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 149# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
161# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 150# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in make.conf.
162qt4-build_src_prepare() { 151qt4-build_src_prepare() {
163 setqtenv 152 setqtenv
164 cd "${S}"
165 153
166 # fix qt 4.7 regression that skips -fvisibility=hidden 154 if [[ ${QT4_BUILD_TYPE} == live ]]; then
167 if version_is_at_least "4.7.0_beta1"; then 155 QTDIR="." ./bin/syncqt || die "syncqt failed"
168 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
169 -i config.tests/unix/fvisibility.test ||
170 die "visibility fixing sed failed"
171 fi 156 fi
157
158 # avoid X11 dependency in non-gui packages
159 local nolibx11_pkgs="qtbearer qtcore qtdbus qtscript qtsql qttest qtxmlpatterns"
160 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
172 161
173 if use aqua; then 162 if use aqua; then
174 # provide a proper macx-g++-64 163 # provide a proper macx-g++-64
175 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 164 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
176 165
177 sed -e '/^CONFIG/s:app_bundle::' \ 166 sed -e '/^CONFIG/s:app_bundle::' \
178 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 167 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
179 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 168 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
180 fi 169 fi
181 170
182 if [[ ${PN} != qt-core ]]; then 171 if [[ ${CATEGORY}/${PN} != dev-qt/qtcore ]]; then
183 skip_qmake_build_patch 172 skip_qmake_build
184 skip_project_generation_patch 173 skip_project_generation
185 symlink_binaries_to_buildtree 174 symlink_binaries_to_buildtree
186 fi 175 else
187 176 # Bug 373061
177 # qmake bus errors with -O2 or -O3 but -O1 works
188 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 178 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
189 # qmake bus errors with -O2 but -O3 works
190 replace-flags -O2 -O3 179 replace-flags -O[23] -O1
191 fi 180 fi
192 181
193 # Bug 178652 182 # Bug 503500
194 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 183 # undefined reference with -Os and --as-needed
195 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 184 if use x86; then
196 append-flags -fno-gcse 185 replace-flags -Os -O2
197 fi 186 fi
198
199 # Unsupported old gcc versions - hardened needs this :(
200 if [[ $(gcc-major-version) -lt 4 ]] ; then
201 ewarn "Appending -fno-stack-protector to CXXFLAGS"
202 append-cxxflags -fno-stack-protector
203 # Bug 253127
204 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
205 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed"
206 fi 187 fi
207 188
208 # Bug 261632 189 # Bug 261632
209 if use ppc64; then 190 if use ppc64; then
210 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
211 append-flags -mminimal-toc 191 append-flags -mminimal-toc
212 fi 192 fi
213 193
214 # Bug 282984 && Bug 295530 194 # Bug 417105
215 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 195 # graphite on gcc 4.7 causes miscompilations
216 -i configure || die "sed qmake compilers failed" 196 if [[ $(gcc-version) == "4.7" ]]; then
217 # bug 321335 197 filter-flags -fgraphite-identity
218 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 198 fi
219 xargs -0 \ 199
220 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX) LINK=$(tc-getCXX):g" \ 200 if use_if_iuse c++0x; then
221 -i || die "sed test compilers failed" 201 append-cxxflags -std=c++0x
202 fi
203
204 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
205 sed -e "/^SYSTEM_VARIABLES=/i \
206 CC='$(tc-getCC)'\n\
207 CXX='$(tc-getCXX)'\n\
208 CFLAGS='${CFLAGS}'\n\
209 CXXFLAGS='${CXXFLAGS}'\n\
210 LDFLAGS='${LDFLAGS}'\n\
211 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
212 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
213 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
214 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
215 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
216 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
217 -i configure \
218 || die "sed SYSTEM_VARIABLES failed"
219
220 # Respect CC, CXX, LINK and *FLAGS in config.tests
221 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
222 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
223 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
224 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
225 || die "sed config.tests failed"
222 226
223 # Bug 172219 227 # Bug 172219
224 sed -e "s:X11R6/::" \ 228 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
225 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
226 229
227 if [[ ${CHOST} == *-darwin* ]]; then 230 if [[ ${CHOST} == *-darwin* ]]; then
228 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 231 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
229 # crippled (by design) :/ 232 # crippled (by design) :/
233 local mac_gpp_conf=
234 if [[ -f mkspecs/common/mac-g++.conf ]]; then
235 # qt < 4.8 has mac-g++.conf
236 mac_gpp_conf="mkspecs/common/mac-g++.conf"
237 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
238 # qt >= 4.8 has g++-macx.conf
239 mac_gpp_conf="mkspecs/common/g++-macx.conf"
240 else
241 die "no known conf file for mac found"
242 fi
243 sed \
230 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 244 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
231 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 245 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
232 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 246 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
233 -e "s:-arch\s\w*::g" \ 247 -e "s:-arch\s\w*::g" \
234 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 248 -i ${mac_gpp_conf} \
249 || die "sed ${mac_gpp_conf} failed"
235 250
236 # Fix configure's -arch settings that appear in qmake/Makefile and also 251 # Fix configure's -arch settings that appear in qmake/Makefile and also
237 # fix arch handling (automagically duplicates our -arch arg and breaks 252 # fix arch handling (automagically duplicates our -arch arg and breaks
238 # pch). Additionally disable Xarch support. 253 # pch). Additionally disable Xarch support.
254 local mac_gcc_confs="${mac_gpp_conf}"
255 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
256 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
257 fi
239 sed \ 258 sed \
240 -e "s:-arch i386::" \ 259 -e "s:-arch i386::" \
241 -e "s:-arch ppc::" \ 260 -e "s:-arch ppc::" \
242 -e "s:-arch x86_64::" \ 261 -e "s:-arch x86_64::" \
243 -e "s:-arch ppc64::" \ 262 -e "s:-arch ppc64::" \
244 -e "s:-arch \$i::" \ 263 -e "s:-arch \$i::" \
245 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 264 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
246 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 265 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
247 -e "s:-Xarch_x86_64::g" \ 266 -e "s:-Xarch_x86_64::g" \
248 -e "s:-Xarch_ppc64::g" \ 267 -e "s:-Xarch_ppc64::g" \
249 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 268 -i configure ${mac_gcc_confs} \
269 || die "sed -arch/-Xarch failed"
250 270
251 # On Snow Leopard don't fall back to 10.5 deployment target. 271 # On Snow Leopard don't fall back to 10.5 deployment target.
252 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 272 if [[ ${CHOST} == *-apple-darwin10 ]]; then
253 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 273 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
254 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 274 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
255 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 275 -i configure ${mac_gpp_conf} \
276 || die "sed deployment target failed"
256 fi 277 fi
257 fi 278 fi
258 279
259 # this one is needed for all systems with a separate -liconv, apart from 280 # this one is needed for all systems with a separate -liconv, apart from
260 # Darwin, for which the sources already cater for -liconv 281 # Darwin, for which the sources already cater for -liconv
261 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 282 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
262 sed \ 283 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
263 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
264 -i config.tests/unix/iconv/iconv.pro \ 284 -i config.tests/unix/iconv/iconv.pro \
265 || die "sed on iconv.pro failed" 285 || die "sed iconv.pro failed"
266 fi 286 fi
267 287
268 # we need some patches for Solaris 288 # we need some patches for Solaris
269 sed -i \
270 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 289 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
271 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 290 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
272 # use GCC over SunStudio 291 # use GCC over SunStudio
273 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 292 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
274 # don't flirt with non-Prefix stuff, we're quite possessive 293 # do not flirt with non-Prefix stuff, we're quite possessive
275 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 294 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
276 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 295 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
277 296
278 base_src_prepare 297 # apply patches
298 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
299 epatch_user
279} 300}
280 301
281# @FUNCTION: qt4-build_src_configure 302# @FUNCTION: qt4-build_src_configure
282# @DESCRIPTION: 303# @DESCRIPTION:
283# Default configure phase 304# Default configure phase
284qt4-build_src_configure() { 305qt4-build_src_configure() {
285 setqtenv 306 setqtenv
286 myconf="$(standard_configure_options) ${myconf}" 307
308 local conf="
309 -prefix ${QTPREFIXDIR}
310 -bindir ${QTBINDIR}
311 -libdir ${QTLIBDIR}
312 -docdir ${QTDOCDIR}
313 -headerdir ${QTHEADERDIR}
314 -plugindir ${QTPLUGINDIR}
315 -importdir ${QTIMPORTDIR}
316 -datadir ${QTDATADIR}
317 -translationdir ${QTTRANSDIR}
318 -sysconfdir ${QTSYSCONFDIR}
319 -examplesdir ${QTEXAMPLESDIR}
320 -demosdir ${QTDEMOSDIR}
321 -opensource -confirm-license
322 -shared -fast -largefile -stl -verbose
323 -nomake examples -nomake demos"
324
325 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
326 # $(tc-arch). Therefore we convert it to supported values.
327 case "$(tc-arch)" in
328 amd64|x64-*) conf+=" -arch x86_64" ;;
329 ppc-macos) conf+=" -arch ppc" ;;
330 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
331 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
332 x86-macos) conf+=" -arch x86" ;;
333 x86|x86-*) conf+=" -arch i386" ;;
334 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
335 arm64|hppa|sh) conf+=" -arch generic" ;;
336 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
337 esac
338
339 conf+=" -platform $(qt_mkspecs_dir)"
340
341 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
342
343 # debug/release
344 if use debug; then
345 conf+=" -debug"
346 else
347 conf+=" -release"
348 fi
349 conf+=" -no-separate-debug-info"
350
351 # exceptions USE flag
352 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
353
354 # disable rpath (bug 380415), except on prefix (bug 417169)
355 use prefix || conf+=" -no-rpath"
356
357 # precompiled headers don't work on hardened, where the flag is masked
358 conf+=" $(qt_use pch)"
359
360 # -reduce-relocations
361 # This flag seems to introduce major breakage to applications,
362 # mostly to be seen as a core dump with the message "QPixmap: Must
363 # construct a QApplication before a QPaintDevice" on Solaris.
364 # -- Daniel Vergien
365 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
287 366
288 # this one is needed for all systems with a separate -liconv, apart from 367 # this one is needed for all systems with a separate -liconv, apart from
289 # Darwin, for which the sources already cater for -liconv 368 # Darwin, for which the sources already cater for -liconv
290 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 369 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
291 myconf+=" -liconv" 370 conf+=" -liconv"
371 fi
292 372
293 if has glib ${IUSE//+} && use glib; then 373 if use_if_iuse glib; then
294 # use -I, -L and -l from configure
295 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 374 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
296 # avoid the -pthread argument 375 # avoid the -pthread argument
297 myconf+=" ${glibflags//-pthread}" 376 conf+=" ${glibflags//-pthread}"
298 unset glibflags 377 unset glibflags
299 fi 378 fi
300 379
301 if use aqua ; then 380 if use aqua; then
302 # On (snow) leopard use the new (frameworked) cocoa code. 381 # On (snow) leopard use the new (frameworked) cocoa code.
303 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 382 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
304 myconf+=" -cocoa -framework" 383 conf+=" -cocoa -framework"
384 # We need the source's headers, not the installed ones.
385 conf+=" -I${S}/include"
386 # Add hint for the framework location.
387 conf+=" -F${QTLIBDIR}"
305 388
306 # We are crazy and build cocoa + qt3support :-) 389 # We are crazy and build cocoa + qt3support :-)
307 if use qt3support; then 390 if use qt3support; then
308 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 391 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
309 -i configure 392 -i configure || die
310 fi 393 fi
311 394 else
312 # We need the source's headers, not the installed ones. 395 conf+=" -no-framework"
313 myconf+=" -I${S}/include"
314
315 # Add hint for the framework location.
316 myconf+=" -F${QTLIBDIR}"
317 fi 396 fi
318 else 397 else
319 # freetype2 include dir is non-standard, thus include it on configure 398 # freetype2 include dir is non-standard, thus pass it to configure
320 # use -I from configure
321 myconf+=" $(pkg-config --cflags freetype2)" 399 conf+=" $(pkg-config --cflags-only-I freetype2)"
322 fi 400 fi
323 401
402 conf+=" ${myconf}"
403 myconf=
404
324 echo ./configure ${myconf} 405 echo ./configure ${conf}
325 ./configure ${myconf} || die "./configure failed" 406 ./configure ${conf} || die "./configure failed"
326 myconf="" 407
408 prepare_directories ${QT4_TARGET_DIRECTORIES}
327} 409}
328 410
329# @FUNCTION: qt4-build_src_compile 411# @FUNCTION: qt4-build_src_compile
412# @DESCRIPTION:
330# @DESCRIPTION: Actual compile phase 413# Actual compile phase
331qt4-build_src_compile() { 414qt4-build_src_compile() {
332 setqtenv 415 setqtenv
333 416
334 build_directories ${QT4_TARGET_DIRECTORIES} 417 build_directories ${QT4_TARGET_DIRECTORIES}
335} 418}
336 419
420# @FUNCTION: qt4-build_src_test
421# @DESCRIPTION:
422# Runs tests only in target directories.
423qt4-build_src_test() {
424 # QtMultimedia does not have any test suite (bug #332299)
425 [[ ${CATEGORY}/${PN} == dev-qt/qtmultimedia ]] && return
426
427 for dir in ${QT4_TARGET_DIRECTORIES}; do
428 emake -j1 check -C ${dir}
429 done
430}
431
337# @FUNCTION: fix_includes 432# @FUNCTION: fix_includes
338# @DESCRIPTION: 433# @DESCRIPTION:
339# For MacOSX we need to add some symlinks when frameworks are 434# For MacOS X we need to add some symlinks when frameworks are
340# being used, to avoid complications with some more or less stupid packages. 435# being used, to avoid complications with some more or less stupid packages.
341fix_includes() { 436fix_includes() {
342 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 437 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
438 local frw dest f h rdir
343 # Some packages tend to include <Qt/...> 439 # Some packages tend to include <Qt/...>
344 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 440 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
345 441
346 # Fake normal headers when frameworks are installed... eases life later on 442 # Fake normal headers when frameworks are installed... eases life later
347 local dest f 443 # on, make sure we use relative links though, as some ebuilds assume
444 # these dirs exist in src_install to add additional files
445 f=${QTHEADERDIR}
446 h=${QTLIBDIR}
447 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
448 f=${f#*/}
449 h=${h#*/}
450 done
451 rdir=${h}
452 f="../"
453 while [[ ${h} == */* ]] ; do
454 f="${f}../"
455 h=${h#*/}
456 done
457 rdir="${f}${rdir}"
458
348 for frw in "${D}${QTLIBDIR}"/*.framework; do 459 for frw in "${D}${QTLIBDIR}"/*.framework; do
349 [[ -e "${frw}"/Headers ]] || continue 460 [[ -e "${frw}"/Headers ]] || continue
350 f=$(basename ${frw}) 461 f=$(basename ${frw})
351 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 462 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
352 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 463 dosym "${rdir}"/${f}/Headers "${dest}"
353 464
354 # Link normal headers as well. 465 # Link normal headers as well.
355 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 466 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
356 h=$(basename ${hdr}) 467 h=$(basename ${hdr})
357 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 468 dosym "../${rdir}"/${f}/Headers/${h} \
469 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
358 done 470 done
359 done 471 done
360 fi 472 fi
361} 473}
362 474
363# @FUNCTION: qt4-build_src_install 475# @FUNCTION: qt4-build_src_install
364# @DESCRIPTION: 476# @DESCRIPTION:
365# Perform the actual installation including some library fixes. 477# Perform the actual installation including some library fixes.
366qt4-build_src_install() { 478qt4-build_src_install() {
367 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
368 setqtenv 479 setqtenv
480
369 install_directories ${QT4_TARGET_DIRECTORIES} 481 install_directories ${QT4_TARGET_DIRECTORIES}
370 install_qconfigs 482 install_qconfigs
371 fix_library_files 483 fix_library_files
372 fix_includes 484 fix_includes
485
486 # remove .la files since we are building only shared libraries
487 prune_libtool_files
373} 488}
374 489
375# @FUNCTION: setqtenv 490# @FUNCTION: setqtenv
491# @INTERNAL
376setqtenv() { 492setqtenv() {
377 # Set up installation directories 493 # Set up installation directories
378 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
379 QTPREFIXDIR=${EPREFIX}/usr 494 QTPREFIXDIR=${EPREFIX}/usr
380 QTBINDIR=${EPREFIX}/usr/bin 495 QTBINDIR=${QTPREFIXDIR}/bin
381 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 496 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
382 QMAKE_LIBDIR_QT=${QTLIBDIR}
383 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 497 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
384 QTDATADIR=${EPREFIX}/usr/share/qt4
385 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 498 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
386 QTHEADERDIR=${EPREFIX}/usr/include/qt4 499 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
387 QTPLUGINDIR=${QTLIBDIR}/plugins 500 QTPLUGINDIR=${QTLIBDIR}/plugins
501 QTIMPORTDIR=${QTLIBDIR}/imports
502 QTDATADIR=${QTPREFIXDIR}/share/qt4
503 QTTRANSDIR=${QTDATADIR}/translations
388 QTSYSCONFDIR=${EPREFIX}/etc/qt4 504 QTSYSCONFDIR=${EPREFIX}/etc/qt4
389 QTTRANSDIR=${QTDATADIR}/translations
390 QTEXAMPLESDIR=${QTDATADIR}/examples 505 QTEXAMPLESDIR=${QTDATADIR}/examples
391 QTDEMOSDIR=${QTDATADIR}/demos 506 QTDEMOSDIR=${QTDATADIR}/demos
392 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 507 QMAKE_LIBDIR_QT=${QTLIBDIR}
508
393 PLATFORM=$(qt_mkspecs_dir) 509 PLATFORM=$(qt_mkspecs_dir)
394
395 unset QMAKESPEC 510 unset QMAKESPEC
396}
397 511
398# @FUNCTION: standard_configure_options 512 export XDG_CONFIG_HOME="${T}"
399# @DESCRIPTION: 513}
400# Sets up some standard configure options, like libdir (if necessary), whether
401# debug info is wanted or not.
402standard_configure_options() {
403 local myconf=
404 514
405 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)" 515# @FUNCTION: prepare_directories
406 516# @USAGE: < directories >
407 # Disable visibility explicitly if gcc version isn't 4 517# @INTERNAL
408 if [[ $(gcc-major-version) -lt 4 ]]; then 518# @DESCRIPTION:
409 myconf+=" -no-reduce-exports" 519# Generates Makefiles for the given list of directories.
410 fi 520prepare_directories() {
411 521 for x in "$@"; do
412 # precompiled headers doesn't work on hardened, where the flag is masked. 522 pushd "${S}"/${x} >/dev/null || die
413 myconf+=" $(qt_use pch)" 523 einfo "Running qmake in: ${x}"
414 524 "${S}"/bin/qmake \
415 if use debug; then 525 "LIBS+=-L${QTLIBDIR}" \
416 myconf+=" -debug" 526 "CONFIG+=nostrip" \
417 else 527 || die "qmake failed"
418 myconf+=" -release" 528 popd >/dev/null || die
419 fi 529 done
420 myconf+=" -no-separate-debug-info"
421
422 use aqua && myconf+=" -no-framework"
423
424 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
425 # $(tc-arch). Therefore we convert it to supported values.
426 case "$(tc-arch)" in
427 amd64|x64-*) myconf+=" -arch x86_64" ;;
428 ppc-macos) myconf+=" -arch ppc" ;;
429 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
430 sparc|sparc-*) myconf+=" -arch sparc" ;;
431 x86-macos) myconf+=" -arch x86" ;;
432 x86|x86-*) myconf+=" -arch i386" ;;
433 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
434 hppa|sh) myconf+=" -arch generic" ;;
435 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
436 esac
437
438 # 4.5: build everything but qt-xmlpatterns w/o exceptions
439 # 4.6: exceptions USE flag
440 local exceptions="-exceptions"
441 case "${PV}" in
442 4.5.*)
443 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
444 ;;
445 *)
446 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
447 ;;
448 esac
449
450 # note about -reduce-relocations:
451 # That flag seems to introduce major breakage to applications,
452 # mostly to be seen as a core dump with the message "QPixmap: Must
453 # construct a QApplication before a QPaintDevice" on Solaris
454 # -- Daniel Vergien
455 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
456
457 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
458 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
459 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
460 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
461 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
462 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
463 ${exceptions}
464 -nomake examples -nomake demos"
465
466 echo "${myconf}"
467} 530}
468 531
469# @FUNCTION: build_directories 532# @FUNCTION: build_directories
470# @USAGE: < directories > 533# @USAGE: < directories >
534# @INTERNAL
471# @DESCRIPTION: 535# @DESCRIPTION:
472# Compiles the code in $QT4_TARGET_DIRECTORIES 536# Compiles the code in the given list of directories.
473build_directories() { 537build_directories() {
474 for x in "$@"; do 538 for x in "$@"; do
475 pushd "${S}"/${x} >/dev/null 539 pushd "${S}"/${x} >/dev/null || die
476 # avoid running over the maximum argument number, bug #299810 540 emake \
477 { 541 AR="$(tc-getAR) cqs" \
478 echo "${S}"/mkspecs/common/*.conf
479 find "${S}" -name '*.pr[io]'
480 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die
481 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
482 emake CC="$(tc-getCC)" \ 542 CC="$(tc-getCC)" \
483 CXX="$(tc-getCXX)" \ 543 CXX="$(tc-getCXX)" \
484 LINK="$(tc-getCXX)" || die "emake failed" 544 LINK="$(tc-getCXX)" \
545 RANLIB=":" \
546 STRIP=":"
485 popd >/dev/null 547 popd >/dev/null || die
486 done 548 done
487} 549}
488 550
489# @FUNCTION: install_directories 551# @FUNCTION: install_directories
490# @USAGE: < directories > 552# @USAGE: < directories >
553# @INTERNAL
491# @DESCRIPTION: 554# @DESCRIPTION:
492# run emake install in the given directories, which are separated by spaces 555# Runs emake install in the given directories, which are separated by spaces.
493install_directories() { 556install_directories() {
494 for x in "$@"; do 557 for x in "$@"; do
495 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 558 pushd "${S}"/${x} >/dev/null || die
496 emake INSTALL_ROOT="${D}" install || die "emake install failed" 559 emake INSTALL_ROOT="${D}" install
497 popd >/dev/null || die "Can't popd from ${S}/${x}" 560 popd >/dev/null || die
498 done 561 done
499} 562}
500 563
501# @ECLASS-VARIABLE: QCONFIG_ADD 564# @ECLASS-VARIABLE: QCONFIG_ADD
502# @DESCRIPTION: 565# @DESCRIPTION:
512# @DESCRIPTION: 575# @DESCRIPTION:
513# List variables that should be defined at the top of QtCore/qconfig.h 576# List variables that should be defined at the top of QtCore/qconfig.h
514: ${QCONFIG_DEFINE:=} 577: ${QCONFIG_DEFINE:=}
515 578
516# @FUNCTION: install_qconfigs 579# @FUNCTION: install_qconfigs
580# @INTERNAL
581# @DESCRIPTION:
517# @DESCRIPTION: Install gentoo-specific mkspecs configurations 582# Install gentoo-specific mkspecs configurations.
518install_qconfigs() { 583install_qconfigs() {
519 local x 584 local x
520 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 585 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
521 for x in QCONFIG_ADD QCONFIG_REMOVE; do 586 for x in QCONFIG_ADD QCONFIG_REMOVE; do
522 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 587 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
523 done 588 done
524 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo 589 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
525 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 590 doins "${T}"/${PN}-qconfig.pri
526 fi 591 fi
527 592
528 if [[ -n ${QCONFIG_DEFINE} ]]; then 593 if [[ -n ${QCONFIG_DEFINE} ]]; then
529 for x in ${QCONFIG_DEFINE}; do 594 for x in ${QCONFIG_DEFINE}; do
530 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 595 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
531 done 596 done
532 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo 597 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
533 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 598 doins "${T}"/gentoo-${PN}-qconfig.h
534 fi 599 fi
535} 600}
536 601
537# @FUNCTION: generate_qconfigs 602# @FUNCTION: generate_qconfigs
538# @DESCRIPTION: Generates gentoo-specific configurations 603# @INTERNAL
604# @DESCRIPTION:
605# Generates gentoo-specific qconfig.{h,pri}.
539generate_qconfigs() { 606generate_qconfigs() {
540 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 607 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == dev-qt/qtcore ]]; then
541 local x qconfig_add qconfig_remove qconfig_new 608 local x qconfig_add qconfig_remove qconfig_new
542 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 609 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
543 [[ -f ${x} ]] || continue 610 [[ -f ${x} ]] || continue
544 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 611 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
545 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 612 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
546 done 613 done
547 614
548 # these error checks do not use die because dying in pkg_post{inst,rm} 615 # these error checks do not use die because dying in pkg_post{inst,rm}
549 # just makes things worse. 616 # just makes things worse.
550 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 617 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
551 # start with the qconfig.pri that qt-core installed 618 # start with the qconfig.pri that qtcore installed
552 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \ 619 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \
553 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 620 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
554 eerror "cp qconfig failed." 621 eerror "cp qconfig failed."
555 return 1 622 return 1
556 fi 623 fi
557 624
558 # generate list of QT_CONFIG entries from the existing list 625 # generate list of QT_CONFIG entries from the existing list
559 # including qconfig_add and excluding qconfig_remove 626 # including qconfig_add and excluding qconfig_remove
560 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 627 for x in $(sed -n 's/^QT_CONFIG +=//p' \
561 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 628 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
562 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 629 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
563 done 630 done
564 631
565 # replace the existing QT_CONFIG list with qconfig_new 632 # replace the existing QT_CONFIG list with qconfig_new
566 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 633 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
567 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 634 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
591 fi 658 fi
592 fi 659 fi
593} 660}
594 661
595# @FUNCTION: qt4-build_pkg_postrm 662# @FUNCTION: qt4-build_pkg_postrm
663# @DESCRIPTION:
596# @DESCRIPTION: Generate configurations when the package is completely removed 664# Regenerate configuration when the package is completely removed.
597qt4-build_pkg_postrm() { 665qt4-build_pkg_postrm() {
598 generate_qconfigs 666 generate_qconfigs
599} 667}
600 668
601# @FUNCTION: qt4-build_pkg_postinst 669# @FUNCTION: qt4-build_pkg_postinst
670# @DESCRIPTION:
602# @DESCRIPTION: Generate configuration, plus throws a message about possible 671# Regenerate configuration, plus throw a message about possible
603# breakages and proposed solutions. 672# breakages and proposed solutions.
604qt4-build_pkg_postinst() { 673qt4-build_pkg_postinst() {
605 generate_qconfigs 674 generate_qconfigs
606} 675}
607 676
608# @FUNCTION: skip_qmake_build_patch 677# @FUNCTION: skip_qmake_build
678# @INTERNAL
609# @DESCRIPTION: 679# @DESCRIPTION:
610# Don't need to build qmake, as it's already installed from qt-core 680# Patches configure to skip qmake compilation, as it's already installed by qtcore.
611skip_qmake_build_patch() { 681skip_qmake_build() {
612 # Don't need to build qmake, as it's already installed from qt-core
613 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 682 sed -i -e "s:if true:if false:g" "${S}"/configure || die
614} 683}
615 684
616# @FUNCTION: skip_project_generation_patch 685# @FUNCTION: skip_project_generation
686# @INTERNAL
617# @DESCRIPTION: 687# @DESCRIPTION:
618# Exit the script early by throwing in an exit before all of the .pro files are scanned 688# Exit the script early by throwing in an exit before all of the .pro files are scanned.
619skip_project_generation_patch() { 689skip_project_generation() {
620 # Exit the script early by throwing in an exit before all of the .pro files are scanned
621 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 690 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
622 -i "${S}"/configure || die "Sed failed"
623} 691}
624 692
625# @FUNCTION: symlink_binaries_to_buildtree 693# @FUNCTION: symlink_binaries_to_buildtree
694# @INTERNAL
626# @DESCRIPTION: 695# @DESCRIPTION:
627# Symlink generated binaries to buildtree so they can be used during compilation 696# Symlinks generated binaries to buildtree, so they can be used during compilation time.
628# time
629symlink_binaries_to_buildtree() { 697symlink_binaries_to_buildtree() {
630 for bin in qmake moc uic rcc; do 698 for bin in qmake moc uic rcc; do
631 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 699 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
632 done 700 done
633} 701}
634 702
635# @FUNCTION: fix_library_files 703# @FUNCTION: fix_library_files
704# @INTERNAL
636# @DESCRIPTION: 705# @DESCRIPTION:
637# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 706# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
638# moves the *.pc-files into the pkgconfig directory 707# moves the *.pc files into the pkgconfig directory.
639fix_library_files() { 708fix_library_files() {
709 local libfile
640 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 710 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
641 if [[ -e ${libfile} ]]; then 711 if [[ -e ${libfile} ]]; then
642 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 712 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
643 fi 713 fi
644 done 714 done
645 715
646 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 716 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
647 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 717 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
648 if [[ -e ${libfile} ]]; then 718 if [[ -e ${libfile} ]]; then
649 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 719 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
650 720
651 # Move .pc files into the pkgconfig directory 721 # Move .pc files into the pkgconfig directory
652 dodir ${QTPCDIR#${EPREFIX}} 722 dodir ${QTPCDIR#${EPREFIX}}
653 mv ${libfile} "${D}"/${QTPCDIR}/ \ 723 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
654 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
655 fi 724 fi
656 done 725 done
657 726
658 # Don't install an empty directory 727 # Don't install an empty directory
659 rmdir "${D}"/${QTLIBDIR}/pkgconfig 728 rmdir "${D}"/${QTLIBDIR}/pkgconfig
660} 729}
661 730
662# @FUNCTION: qt_use 731# @FUNCTION: qt_use
663# @USAGE: < flag > [ feature ] [ enableval ] 732# @USAGE: < flag > [ feature ] [ enableval ]
664# @DESCRIPTION: 733# @DESCRIPTION:
665# This will echo "${enableval}-${feature}" if <flag> is enabled, or 734# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
666# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 735# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
667# will be used for that. If [enableval] is not specified, it omits the 736# will be used for that. If [enableval] is not specified, it omits the
668# assignment-part 737# "-${enableval}" part.
669qt_use() { 738qt_use() {
670 local flag=$1 739 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
671 local feature=$1
672 local enableval=
673
674 [[ -n $2 ]] && feature=$2
675 [[ -n $3 ]] && enableval=-$3
676
677 if use ${flag}; then
678 echo "${enableval}-${feature}"
679 else
680 echo "-no-${feature}"
681 fi
682} 740}
683 741
684# @FUNCTION: qt_mkspecs_dir 742# @FUNCTION: qt_mkspecs_dir
685# @RETURN: the specs-directory w/o path 743# @RETURN: the specs-directory w/o path
686# @DESCRIPTION: 744# @DESCRIPTION:
687# Allows us to define which mkspecs dir we want to use. 745# Allows us to define which mkspecs dir we want to use.
688qt_mkspecs_dir() { 746qt_mkspecs_dir() {
689 # Allows us to define which mkspecs dir we want to use.
690 local spec 747 local spec=
691 748
692 case ${CHOST} in 749 case "${CHOST}" in
693 *-freebsd*|*-dragonfly*) 750 *-freebsd*|*-dragonfly*)
694 spec=freebsd ;; 751 spec=freebsd ;;
695 *-openbsd*) 752 *-openbsd*)
696 spec=openbsd ;; 753 spec=openbsd ;;
697 *-netbsd*) 754 *-netbsd*)
708 *-solaris*) 765 *-solaris*)
709 spec=solaris ;; 766 spec=solaris ;;
710 *-linux-*|*-linux) 767 *-linux-*|*-linux)
711 spec=linux ;; 768 spec=linux ;;
712 *) 769 *)
713 die "Unknown CHOST, no platform choosen." 770 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
714 esac 771 esac
715 772
716 CXX=$(tc-getCXX) 773 case "$(tc-getCXX)" in
717 if [[ ${CXX} == *g++* ]]; then 774 *g++*)
718 spec+=-g++ 775 spec+=-g++ ;;
719 elif [[ ${CXX} == *icpc* ]]; then 776 *icpc*)
720 spec+=-icc 777 spec+=-icc ;;
721 else 778 *)
722 die "Unknown compiler ${CXX}." 779 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
723 fi 780 esac
724 if [[ -n ${LIBDIR/lib} ]]; then
725 spec+=-${LIBDIR/lib}
726 fi
727 781
728 # Add -64 for 64bit profiles 782 # Add -64 for 64bit profiles
729 if use x64-freebsd || 783 if use x64-freebsd ||
730 use amd64-linux || 784 use amd64-linux ||
731 use x64-macos || 785 use x64-macos ||
736 fi 790 fi
737 791
738 echo "${spec}" 792 echo "${spec}"
739} 793}
740 794
795# @FUNCTION: qt_nolibx11
796# @INTERNAL
797# @DESCRIPTION:
798# Skip X11 tests for packages that don't need X libraries installed.
799qt_nolibx11() {
800 sed -i -e '/^if.*PLATFORM_X11.*CFG_GUI/,/^fi$/d' "${S}"/configure || die
801}
802
741EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst 803EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.72  
changed lines
  Added in v.1.162

  ViewVC Help
Powered by ViewVC 1.1.20